#include <bits/stdc++.h>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i < (b); i++)
#define RFOR(i, a, b) for(int i = (a) - 1; i >= (b); i--)
#define SZ(a) int(a.size())
#define ALL(a) a.begin(), a.end()
#define PB push_back
#define MP make_pair
#define F first
#define S second

typedef long long LL;
typedef vector<int> VI;
typedef pair<int, int> PII;
typedef double db;

const int INF = 1e9 + 7;

void solve()
{
	int n;
	cin >> n;
	VI a(n), b(n);
	for (int& ai : a)
		cin >> ai;
	for (int& bi : b)
		cin >> bi;
	sort(ALL(a));
	sort(ALL(b));
	int ans = 0;
	FOR(j, 0, n)
	{
		int cur = INF;
		FOR(i, 0, n)
		{
			int k = i + j;
			if (k >= n)
				k -= n;
			cur = min(cur, abs(a[i] - b[k]));
		}
		ans = max(ans, cur);
	}
	cout << ans << "\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}
